#include "NamedCounterIteratorImpl.h"

#include <iostream>
using std::cout;
using std::endl;

#pragma warning(disable : 4786)  // identifier was truncated to '255' characters in the debug information

NamedCounterIteratorImpl::NamedCounterIteratorImpl(
   NamedCounterFactoryImpl::CounterContainer &counters)
	:	EvictorBase("NamedCounterIteratorImpl"),
      m_counters(counters),
      m_current(counters.beginList())
{ 
	cout << "NamedCounterIteratorImpl::NamedCounterIteratorImpl() - " << this <<   endl; 
}

NamedCounterIteratorImpl::~NamedCounterIteratorImpl()
{
	cout << "NamedCounterIteratorImpl::~NamedCounterIteratorImpl() - " << this <<   endl; 
}

CORBA::Boolean NamedCounterIteratorImpl::next_n(
   CORBA::ULong how_many, 
	counterSeq_out theCounters)
{
	cout << "NamedCounterIteratorImpl::next_n() - " << how_many << endl; 

   long numCounters = 0;

   theCounters = new counterSeq(how_many);

   theCounters->length(how_many);

   while (m_current != m_counters.endList() && 
          numCounters < how_many)
   {
      (*m_current)->AddRef();
      (*theCounters)[numCounters] = NamedCounter::_duplicate((*m_current)->_this());
	   ++m_current;
      ++numCounters;
   }

   theCounters->length(numCounters);

   return (numCounters != 0);
}

void NamedCounterIteratorImpl::destroy()
{
   EvictorBase::destroy();
}

bool NamedCounterIteratorImpl::AtEnd()
{
   return (m_current == m_counters.endList());
}

